<?php
// includes
require_once 'propel/Propel.php';
require_once 'util/Config.php';

class Transaction {

	// Lightweight
	static $ta_arr = array(); // this initialization has no effect!
	static function getInstance($appl = "DEFAULT") {
		if (!isset(self::$ta_arr[$appl])) {
			self::$ta_arr[$appl] = new Transaction($appl);
		}
		return self::$ta_arr[$appl];
	}

	// store current application
	private static $currentApplication;
	private $application;
	
	public static function getCurrentApplication() {
		return self::$currentApplication;
	}
	
	function __construct($appl) {

		// get application specific pathes
		$path = preg_replace("/util.*/", "", __FILE__);
		if ($appl == "DEFAULT")
			$propel_path = Config::getInstance()->requireConfig("PropelClassPath");
		else
			$propel_path = Config::getInstance()->requireConfig("$appl::PropelClassPath");
			
		$this->application = $appl;
		
		// init propel
		// @TODO: Ein mehrfaches Propel::init überschreibt offene TAs
		Propel::init("$path/$propel_path/conf/propel-conf.php");
		$include_pathes = get_include_path();
		
		// Add the generated 'classes' directory to the include path
		set_include_path("$path/$propel_path/classes" . PATH_SEPARATOR . get_include_path());
		$include_pathes = get_include_path();
		
		$this->connection = Propel::getConnection();
	}
	
	// instance stuff
	private $connection;
	function getConnection() {
		return $this->connection;
	}
	
	function startTA(){
		$this->connection->beginTransaction();
		self::$currentApplication = $this->application;
	}

	function commitTA(){
		$this->connection->commit();
	}

	function rollbackTA(){
		$this->connection->rollBack();
	}
}

//Transaction::$ta_arr = array();
